"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequestConsolidator = void 0;
class RequestConsolidator {
    constructor() {
        this.promiseMap = {};
    }
    queue(type, promise) {
        let promiseConsolidator = this.promiseMap[type];
        if (!promiseConsolidator) {
            promiseConsolidator = new PromiseConsolidator(() => {
                delete this.promiseMap[type];
            });
            this.promiseMap[type] = promiseConsolidator;
        }
        promiseConsolidator.addPromise(promise);
        return promiseConsolidator.result;
    }
}
exports.RequestConsolidator = RequestConsolidator;
class PromiseConsolidator {
    constructor(finallyFunction) {
        this.finally = finallyFunction;
        this.result = new Promise((resolve, reject) => {
            this.resolve = resolve;
            this.reject = reject;
        });
    }
    addPromise(promise) {
        this.currentPromise = promise;
        promise
            .then((result) => {
            var _a;
            if (promise === this.currentPromise) {
                this.resolve(result);
                (_a = this.finally) === null || _a === void 0 ? void 0 : _a.call(this);
            }
        })
            .catch((error) => {
            var _a;
            this.reject(error);
            (_a = this.finally) === null || _a === void 0 ? void 0 : _a.call(this);
        });
    }
}
//# sourceMappingURL=RequestConsolidator.js.map