"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Store = exports.StoreKey = void 0;
exports.StoreKey = {
    Config: 'dvc:config',
    User: 'dvc:user',
    AnonUser: 'dvc:anonymous_user'
};
class Store {
    constructor(localStorage) {
        this.store = localStorage;
    }
    save(storeKey, data) {
        return this.modifyStore((storeKey) => {
            var _a;
            (_a = this.store) === null || _a === void 0 ? void 0 : _a.setItem(storeKey, JSON.stringify(data));
        }, storeKey);
    }
    load(storeKey) {
        return new Promise((resolve) => {
            var _a;
            resolve((_a = this.store) === null || _a === void 0 ? void 0 : _a.getItem(storeKey));
        });
    }
    clear(storeKey) {
        return this.modifyStore((storeKey) => { var _a; return (_a = this.store) === null || _a === void 0 ? void 0 : _a.removeItem(storeKey); }, storeKey);
    }
    modifyStore(modify, storeKey) {
        try {
            return new Promise((resolve) => {
                resolve(modify(storeKey));
            });
        }
        catch (e) {
            console.log(e);
            return Promise.resolve();
        }
    }
    saveConfig(data) {
        return this.save(exports.StoreKey.Config, data);
    }
    loadConfig() {
        return this.load(exports.StoreKey.Config);
    }
    saveUser(user) {
        if (!user) {
            return Promise.reject('No user to save');
        }
        const saveUserPromise = this.save(exports.StoreKey.User, user);
        if (user.isAnonymous) {
            saveUserPromise.then(() => this.save(exports.StoreKey.AnonUser, user));
        }
        return saveUserPromise;
    }
    loadUser() {
        return this.load(exports.StoreKey.User);
    }
}
exports.Store = Store;
exports.default = Store;
//# sourceMappingURL=Store.js.map