"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DVCPopulatedUser = void 0;
const uuid_1 = require("uuid");
const packageJson = __importStar(require("../package.json"));
const ua_parser_js_1 = __importDefault(require("ua-parser-js"));
class DVCPopulatedUser {
    constructor(user, options) {
        if (!user.user_id && !user.isAnonymous) {
            throw new Error('Must have a user_id, or have "isAnonymous" set on the user');
        }
        this.user_id = !user.user_id ? (0, uuid_1.v4)() : user.user_id;
        this.isAnonymous = user.user_id ? false : user.isAnonymous;
        this.email = user.email;
        this.name = user.name;
        this.language = user.language;
        this.country = user.country;
        this.appVersion = user.appVersion;
        this.appBuild = user.appBuild;
        this.customData = user.customData;
        this.privateCustomData = user.privateCustomData;
        this.lastSeenDate = new Date();
        /**
         * Read only properties initialized once
         */
        const userAgent = new ua_parser_js_1.default(window.navigator.userAgent);
        const platformVersion = userAgent.getBrowser().name &&
            `${userAgent.getBrowser().name} ${userAgent.getBrowser().version}`;
        this.createdDate = new Date();
        this.platform = (options === null || options === void 0 ? void 0 : options.reactNative) ? 'ReactNative' : 'web';
        this.platformVersion = platformVersion !== null && platformVersion !== void 0 ? platformVersion : 'unknown';
        this.deviceModel = (options === null || options === void 0 ? void 0 : options.reactNative) && globalThis.DeviceInfo
            ? globalThis.DeviceInfo.getModel()
            : window.navigator.userAgent;
        this.sdkType = 'client';
        this.sdkVersion = packageJson.version;
    }
    updateUser(user) {
        if (this.user_id !== user.user_id) {
            throw new Error('Cannot update a user with a different user_id');
        }
        this.email = user.email;
        this.name = user.name;
        this.language = user.language;
        this.country = user.country;
        this.appVersion = user.appVersion;
        this.appBuild = user.appBuild;
        this.customData = user.customData;
        this.privateCustomData = user.privateCustomData;
        this.lastSeenDate = new Date();
        return this;
    }
}
exports.DVCPopulatedUser = DVCPopulatedUser;
//# sourceMappingURL=User.js.map