"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initialize = void 0;
const User_1 = require("./User");
const Client_1 = require("./Client");
__exportStar(require("./types"), exports);
const initialize = (environmentKey, user, options) => {
    // TODO: implement logger
    if (!window) {
        console.log('Window is not defined, try initializing in a browser context');
    }
    if (!window.addEventListener && !(options === null || options === void 0 ? void 0 : options.reactNative)) {
        throw new Error('Window is not defined, try initializing in a browser context.' +
            ' If running on React Native, initialize with the option reactNative: true');
    }
    if ((options === null || options === void 0 ? void 0 : options.reactNative) && !globalThis.DeviceInfo) {
        throw new Error('DeviceInfo is not defined. ' +
            'Import react-native-device-info and set global.DeviceInfo when running on React Native');
    }
    if (!environmentKey) {
        throw new Error('Missing environment key! Call initialize with a valid environment key');
    }
    const dvcUser = new User_1.DVCPopulatedUser(user, options);
    const client = new Client_1.DVCClient(environmentKey, dvcUser, options);
    client.onClientInitialized()
        .then(() => console.log('Successfully initialized DevCycle!'))
        .catch((err) => console.log(`Error initializing DevCycle: ${err}`));
    if (!(options === null || options === void 0 ? void 0 : options.reactNative)) {
        window.addEventListener('pagehide', () => {
            client.flushEvents();
        });
    }
    return client;
};
exports.initialize = initialize;
exports.default = { initialize: exports.initialize };
//# sourceMappingURL=index.js.map